	ORG $3000
	LDS #$9FFF
	IF (((128+vars_after-(*+2))|(127-vars_after+(*+2)))&0x8000)
	JMP vars_after
	ELSE
	BRA vars_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*    INTERNAL VARIABLES FOR THOMSON MO6/OLIVETTI PRODEST PC128 TARGET         *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

TEXTADDRESS         fdb     $0000
BITMAPADDRESS       fdb     $0000
COLORMAPADDRESS     fdb     $0000
MOBADDRESS          fdb     $a000
CURRENTMODE         fcb     $0
EVERYSTATUS        fcb     0

TABCOUNT            fcb     4
XCURS               fcb     0
YCURS               fcb     0
EMPTYTILE           fcb     $60

TMPPTR equ $10    ; $23
TMPPTR2 equ $12    ; $25

MATHPTR0 equ $14
MATHPTR1 equ $15
MATHPTR2 equ $16
MATHPTR3 equ $17
MATHPTR4 equ $18
MATHPTR5 equ $19
MATHPTR6 equ $1a
MATHPTR7 equ $1b
MATHPTR8 equ $1c
MATHPTRB0 equ $1d
MATHPTRB1 equ $1e
MATHPTRB2 equ $1f
MATHPTRB3 equ $20
MATHPTRB4 equ $21
MATHPTRB5 equ $22
MATHPTRB6 equ $23
MATHPTRB7 equ $24
MATHPTRB8 equ $25

DSSTATUS equ $3b
DSSIZE equ $3c
DSADDRLO equ $3d
DSADDRHI equ $3e
DSBANKLO equ $3f
DSBANKHI equ $40

COPYOFTEXTADDRESS equ $41
COPYOFBITMAPADDRESS equ $43
COPYOFCOLORMAPADDRESS equ $45
COPYOFTEXTADDRESS2 equ $47
COPYOFCOLORMAPADDRESS2 equ $49

DIRECTION equ $4a
PATTERN equ $4a
CHARACTERS equ $4a
CLINEX equ $4b
CLINEY equ $4c

BITSTOCONVERT equ $4a

XCURSYS fcb 0
YCURSYS fcb 0

vars_after
	IF (((128+startup_after-(*+2))|(127-startup_after+(*+2)))&0x8000)
	JMP startup_after
	ELSE
	BRA startup_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*                          STARTUP ROUTINE ON THOMSON MO5                     *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; TIMER service routine
MO5IRQ
    LDD   #1          ; increment 
MO5TIMER  set *+1     ; (variable within code)
    ADDD  #0          ; add value of TI variable
    STD   MO5TIMER    ; write result to TI variable
    LDX   #0          ; get next ISR
MO5IRQN   set *-2     ; (variable within code)
    BEQ   MO5IRQ2     ; any defined ?
    JSR   ,X          ; yes ==> call it
MO5IRQ2
    JMP   >MO5IRQEND  ; no ==> jmp to the old one
MO5IRQO   set *-2     ; (variable within code)
MO5IRQEND
    RTI               ;  by defaut do RTI
    
MO5STARTUP
    LDX   #$2061
    LDA   2,X         ; Is previous TIMERPT enable ?
    BEQ   MO5STARTUP2 ; no ==> keep default return code (RTI)
    LDD   ,X          ; yes ==> backup previous ISR
    STD   MO5IRQO     ;         and chain it at the end of our own
MO5STARTUP2    
    LDD   #MO5IRQ     ; install our own ISR
    STD   ,X
    LDA   #$21        ; any non-zero value will do, let's use the one that'll go to DP
    STA   2,X         ; enable the ISR

    TFR   A,DP       
    
    LDB   #$14        ; shut down cursor
    SWI
    FCB   $02
    
    RTS
startup_after
	JSR MO5STARTUP
	LDB #$07
	STB _PEN
	CLRA
	STA _PAPER
; peephole: rule #17 (A already 0)
;	CLRA
	STA _windowE
; peephole: rule #17 (A already 0)
;	CLRA
	STA _windowS
; peephole: rule #17 (A already 0)
;	CLRA
	STA _windowW
	LDB #$04
	STB _windowT
; peephole: rule #17 (A already 0)
;	CLRA
	STA _windowMX
; peephole: rule #17 (A already 0)
;	CLRA
	STA _windowMY
	IF (((128+ef936xvars_after-(*+2))|(127-ef936xvars_after+(*+2)))&0x8000)
	JMP ef936xvars_after
	ELSE
	BRA ef936xvars_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*                       INTERNAL VARIABLES FOR EF936X HARDWARE                *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PLOTDEST equ $0b ; $29
PLOTCDEST equ $0d ; $27
PLOTC2DEST equ $0f ; $25

XGR    fdb 0
YGR    fdb 0
LINE   fcb $ff, $ff

CLIPX1    fdb 0
CLIPY1    fdb 0
CLIPX2    fdb 319
CLIPY2    fdb 199
LASTCOLOR fcb 0
CURRENTWIDTH      fdb 320
CURRENTHEIGHT      fdb 200
CURRENTTILESWIDTH      fcb 40
CURRENTTILESHEIGHT      fcb 25
CURRENTFRAMESIZE   fdb 40*200
CURRENTSL          fcb 40
TEXTWW      fcb 3

IMAGEX EQU $41 ; $42
IMAGEY EQU $43 ; $44
IMAGEW EQU $45
IMAGEH EQU $46
IMAGEH2 EQU $47
IMAGET EQU $48

; ------------------------------------------------------------------------------
; BITMAP MODE 16 (MODE #3)
; ------------------------------------------------------------------------------

PLOTVBASE
    fdb $0000, $0028, $0050, $0078, $00A0, $00C8, $00F0, $0118, $0140, $0168
    fdb $0190, $01B8, $01E0, $0208, $0230, $0258, $0280, $02A8, $02D0, $02F8
    fdb $0320, $0348, $0370, $0398, $03C0, $03E8, $0410, $0438, $0460, $0488
    fdb $04B0, $04D8, $0500, $0528, $0550, $0578, $05A0, $05C8, $05F0, $0618
    fdb $0640, $0668, $0690, $06B8, $06E0, $0708, $0730, $0758, $0780, $07A8
    fdb $07D0, $07F8, $0820, $0848, $0870, $0898, $08C0, $08E8, $0910, $0938
    fdb $0960, $0988, $09B0, $09D8, $0A00, $0A28, $0A50, $0A78, $0AA0, $0AC8
    fdb $0AF0, $0B18, $0B40, $0B68, $0B90, $0BB8, $0BE0, $0C08, $0C30, $0C58
    fdb $0C80, $0CA8, $0CD0, $0CF8, $0D20, $0D48, $0D70, $0D98, $0DC0, $0DE8
    fdb $0E10, $0E38, $0E60, $0E88, $0EB0, $0ED8, $0F00, $0F28, $0F50, $0F78
    fdb $0FA0, $0FC8, $0FF0, $1018, $1040, $1068, $1090, $10B8, $10E0, $1108
    fdb $1130, $1158, $1180, $11A8, $11D0, $11F8, $1220, $1248, $1270, $1298
    fdb $12C0, $12E8, $1310, $1338, $1360, $1388, $13B0, $13D8, $1400, $1428
    fdb $1450, $1478, $14A0, $14C8, $14F0, $1518, $1540, $1568, $1590, $15B8
    fdb $15E0, $1608, $1630, $1658, $1680, $16A8, $16D0, $16F8, $1720, $1748
    fdb $1770, $1798, $17C0, $17E8, $1810, $1838, $1860, $1888, $18B0, $18D8
    fdb $1900, $1928, $1950, $1978, $19A0, $19C8, $19F0, $1A18, $1A40, $1A68
    fdb $1A90, $1AB8, $1AE0, $1B08, $1B30, $1B58, $1B80, $1BA8, $1BD0, $1BF8
    fdb $1C20, $1C48, $1C70, $1C98, $1CC0, $1CE8, $1D10, $1D38, $1D60, $1D88
    fdb $1DB0, $1DD8, $1E00, $1E28, $1E50, $1E78, $1EA0, $1EC8, $1EF0, $1F18

    
ef936xvars_after
	IF (((128+ef936xstartup_after-(*+2))|(127-ef936xstartup_after+(*+2)))&0x8000)
	JMP ef936xstartup_after
	ELSE
	BRA ef936xstartup_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*                          STARTUP ROUTINE ON EF936X                          *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

EF936XSTARTUP
    LDU #COMMONPALETTE
    LDY #$A7DA
    LDX #16
; peephole: rule #5 (LDr #0->CLRr)
;    LDA #0
	CLRA
    STA 1,Y
EF936XSTARTUPL1
    PULU D
    STB ,Y
    STA ,Y
    LEAX -1,X
    BNE EF936XSTARTUPL1
    RTS
ef936xstartup_after
	JSR EF936XSTARTUP
	IF (((128+cls_after-(*+2))|(127-cls_after+(*+2)))&0x8000)
	JMP cls_after
	ELSE
	BRA cls_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*                       CLEAR SCREEN ROUTINE FOR EF936X                       *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                     mc6809 optimization by Samuel Devulder                  *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

CLS
    PSHS  DP
    LDA #$A7
    TFR A,DP

    LDA <$C0
    ANDA #$FE
    STA <$C0

    LDA CURRENTMODE
    BEQ CLS0
    DECA
    BEQ CLS1
    DECA
    BEQ CLS2
    DECA
    BEQ CLS3
    DECA
    BEQ CLS4
    PULS DP,PC

CLS2
    CLRA
    LDB _PAPER
    LSRB
    SBCA #0

    LSRB
    LDB #1-1 ; important not 0 or else the optimzer will CLRB which clears the carry
    SBCB #0

    LDU #0
    LEAU B,U
    TFR A,B
    BRA CLSG

CLS3
    LDA _PAPER
    ANDA #$0F
    LDB #$11
    MUL
    TFR B,A
    TFR D,U
    BRA CLSG

CLS0
CLS1
CLS4
    LDA _PEN
    ASLA
    ASLA
    ASLA
    ASLA
    STA ,-S
    LDA _PAPER
    ANDA #$0F
    ORA ,S+
    TFR A,B
    LDU #0
    
CLSG
    LDX BITMAPADDRESS
    LEAX 10,X
    PSHS D,U
    LDD CURRENTFRAMESIZE
    LEAU D,X
    STU CLSGL2+1
    PULS D,U
CLSGL1
    INC <$C0
    STU -10,X
    STU -8,X
    STU -6,X
    STU -4,X
    STU -2,X
    STU ,X
    STU 2,X
    STU 4,X
    STU 6,X
    STU 8,X
    DEC <$C0
    STD -10,X
    STD -8,X
    STD -6,X
    STD -4,X
    STD -2,X
    STD ,X
    STD 2,X
    STD 4,X
    STD 6,X
    STD 8,X
    LEAX 20,X
CLSGL2
    CMPX #$5555
    BLO CLSGL1
    PULS DP,PC


cls_after
	JSR CLS
_numr equ $03e8
_nums equ $0019
_speed equ $0008
_bg equ $0000
	LDA #%00000000
	STA $A7DC
	LDD #$0000
	STD CLIPX1
	LDD #$013f
	STD CLIPX2
	LDD #$0000
	STD CLIPY1
; peephole: rule #20 (A already 0)
;	LDD #$00c7
	LDB #$c7
	STD CLIPY2
	LDD #$1f40
	STD CURRENTFRAMESIZE
	LDD #$0140
	STD CURRENTWIDTH
	LDD #$00c8
	STD CURRENTHEIGHT
	LDB #$28
	STB CURRENTTILESWIDTH
	LDB #$19
	STB CURRENTTILESHEIGHT
; peephole: rule #17 (A already 0)
;	CLRA
	STA CURRENTMODE
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
	CLRB
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp1
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp1
	LSLA
	ANDA #%00011110
	STA ,-S
	LDA $A7C0
	ANDA #%11100001
	ORA ,S+
	STA $A7C0
; peephole: rule #24 (B already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDA #$00
	CLRA
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp1
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp1
	STA _PAPER
	JSR CLS
	JSR CLS
	LDD #$0000
	STD _Ttmp0
	LDD #$03e8
	STD _Ttmp2
	LDD #$0000
	STD _i
	; _Ttmp3 <-> (step 1) (resident)
	; _Ttmp4 <-> (resident to) (resident)
	LDD _Ttmp2
	STD _Ttmp4
	LDD #$0001
	STD _Ttmp3
	LDD _Ttmp0
	STD _i
_label5bf
	CLRA
	LDX _i
	CMPX _Ttmp4
	BLS _label8
	DECA
_label8
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label5bis-(*+2))|(127-_label5bis+(*+2)))&0x8000)
	LBNE _label5bis
	ELSE
	BNE _label5bis
	ENDIF
	LDX CURRENTWIDTH
	STX _Ttmp9
; peephole: unsafe
;	LDD #$0000
	CLRA
; peephole: unsafe
;	STD _Ttmp14
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _Ttmp9
; peephole: rule #12 (LDD *->STD <tmp>->LDX *->CMPX <tmp>)
;	CMPX _Ttmp14
; peephole: rule #11 (LDr->CMPr #0)
;	CMPX #$0000
	BNE _label18
	DECA
_label18
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label19e0-(*+2))|(127-_label19e0+(*+2)))&0x8000)
	LBEQ _label19e0
	ELSE
	BEQ _label19e0
	ENDIF
_label19t
	IF (((128+_label15lr-(*+2))|(127-_label15lr+(*+2)))&0x8000)
	JMP _label15lr
	ELSE
	BRA _label15lr
	ENDIF
_label19f
_label19e0
	IF (((128+cpu_random_after-(*+2))|(127-cpu_random_after+(*+2)))&0x8000)
	JMP cpu_random_after
	ELSE
	BRA cpu_random_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/

CPURANDOM_SEED             fcb $f0, $f0, $f0, $f0
CPURANDOMINTERNALSEED      fcb $42, $45, $20, $21

CPURANDOM0
    LDD CPURANDOMINTERNALSEED
    STD CPURANDOM_SEED
    LDD CPURANDOMINTERNALSEED+2
    STD CPURANDOM_SEED+2
CPURANDOM
    LDD CPURANDOM_SEED
    ASLB
    ASLB
    ROLA
    ADDD CPURANDOM_SEED+2
    LSR CPURANDOM_SEED
    ROR CPURANDOM_SEED+1
    STA CPURANDOM_SEED+3
    ASLB
    ROLA
    EORA <PATTERN ; (entropy)
    ASLB
    ROLA
    EORB <PATTERN ; (entropy)
    ASLB
    ROLA
    ADDD CPURANDOM_SEED+1
    STD CPURANDOM_SEED+1

    LDD CPURANDOM_SEED
    STD CPURANDOMINTERNALSEED
    LDD CPURANDOM_SEED+2    
    STD CPURANDOMINTERNALSEED+2
    RTS
cpu_random_after
	LDA (MO5TIMER+1)
	STA <PATTERN
	JSR CPURANDOM
	LDD CPURANDOM_SEED+2
	STD _Ttmp20
	IF (((128+cpu_math_div_16bit_to_16bit_after-(*+2))|(127-cpu_math_div_16bit_to_16bit_after+(*+2)))&0x8000)
	JMP cpu_math_div_16bit_to_16bit_after
	ELSE
	BRA cpu_math_div_16bit_to_16bit_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/

; unsigned division
; D=D/X X=D.mod.X
; http://www.logicielsmoto.com/phpBB/viewtopic.php?p=1090#p1090

CPUMATHDIV16BITTO16BIT
    PSHS  D
    STX   CPUMATHDIV16BITTO16BITL2-2
    STX   CPUMATHDIV16BITTO16BITL2-7
    LEAY  1,S
    CLRA
    CLRB
    LDX   #16
CPUMATHDIV16BITTO16BITL1
    ROL   ,Y
    ROL   ,S
    ROLB
    ROLA
    CMPD  #$5555
    BCS   CPUMATHDIV16BITTO16BITL2
    SUBD  #$5555
CPUMATHDIV16BITTO16BITL2
    LEAX  -1,X
    BNE   CPUMATHDIV16BITTO16BITL1
    TFR   D,X
    PULS  D
    ROLB
    ROLA
    COMB
    COMA
    RTS

CPUMATHDIV16BITTO16BIT_SIGNED
    PSHS  D,X,Y   ; Y doesn't matter. It is just a placeholder for the sign
    EORA  2,S     ; compute sign of result
    STA   4,S     ; store it on stack
    LDD   #0      ; D=-X
    SUBD  2,S     ; X < 0 ?
    BMI   CPUMATHDIV16BITTO16BIT_SIGNED1
    STD   2,S     ; yes ==> repmace with -X
CPUMATHDIV16BITTO16BIT_SIGNED1
    PULS  D,X
    TSTA          ; D < 0 ?
    BPL   CPUMATHDIV16BITTO16BIT_SIGNED2
    NEGA          ; yes => negate D
    NEGB
    SBCA  #0
CPUMATHDIV16BITTO16BIT_SIGNED2    
    BSR   CPUMATHDIV16BITTO16BIT
    TST   ,S++    ; get sign of result
    BPL   CPUMATHDIV16BITTO16BIT_SIGNED3    
    NEGA          ; negative ? 
    NEGB          ; yes => negate D
    SBCA  #0
CPUMATHDIV16BITTO16BIT_SIGNED3
    RTS

cpu_math_div_16bit_to_16bit_after
	LDD _Ttmp20
	LDX _Ttmp9
	JSR CPUMATHDIV16BITTO16BIT
	STX _Ttmp13
	STD _Ttmp12
	LDD _Ttmp13
	STD _Ttmp20
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD _Ttmp13
	STD _Ttmp11
	IF (((128+_label15end-(*+2))|(127-_label15end+(*+2)))&0x8000)
	JMP _label15end
	ELSE
	BRA _label15end
	ENDIF
_label15lr
	LDD _Ttmp11+2
	STD _Ttmp20
_label15end
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	IF (((128+cpu_math_mul_16bit_to_32bit_after-(*+2))|(127-cpu_math_mul_16bit_to_32bit_after+(*+2)))&0x8000)
	JMP cpu_math_mul_16bit_to_32bit_after
	ELSE
	BRA cpu_math_mul_16bit_to_32bit_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/

CPUMATHMUL16BITTO32BIT
    STD   <MATHPTR0
    STX   <MATHPTR2
CPUMATHMUL16BITTO32BIT0    
    LDB   <MATHPTR2
    MUL            
    PSHS  D

    LDA   <MATHPTR1
    LDB   <MATHPTR3
    MUL
    PSHS  D

    LDD   <MATHPTR1
    MUL
    STD   CPUMATHMUL16BITTO32BIT1-2
    
    LDA   <MATHPTR0
    LDB   <MATHPTR3
    MUL
    ADDD  #$5555
CPUMATHMUL16BITTO32BIT1
    BNE   CPUMATHMUL16BITTO32BIT2
    INC   2,S
    
CPUMATHMUL16BITTO32BIT2
    ADDB  ,S
    STB   ,S
    ADCA  3,S
    STA   3,S
    BCC   CPUMATHMUL16BITTO32BIT3
    INC   2,S
CPUMATHMUL16BITTO32BIT3
    PULS  D,X,PC

CPUMATHMUL16BITTO32BIT_SIGNED
    STX   <MATHPTR2
    STD   <MATHPTR0
    EORA  <MATHPTR2     ; sign of product
    STA   CPUMATHMUL16BITTO32BIT_SIGNED2a+1
    
    LDD   <MATHPTR2     ; Y<0 ?
    BPL   CPUMATHMUL16BITTO32BIT_SIGNED1
    NEGA                ; yes ==> negate
    NEGB
    SBCA  #0
CPUMATHMUL16BITTO32BIT_SIGNED1
    TFR   D,X

    LDD   <MATHPTR0     ; X<0 ?
    BPL   CPUMATHMUL16BITTO32BIT_SIGNED2
    NEGA                ; yes ==> negate
    NEGB
    SBCA  #0
    
CPUMATHMUL16BITTO32BIT_SIGNED2
    BSR   CPUMATHMUL16BITTO32BIT

CPUMATHMUL16BITTO32BIT_SIGNED2a    
    LDA   #$55       ; result<0 ?
    BMI   CPUMATHMUL16BITTO32BIT_SIGNED3
    RTS
CPUMATHMUL16BITTO32BIT_SIGNED3    
    PSHS  X
    COM   1,S     ; yes ==> negate
    COM   ,S
    COMA
    NEGB
    BNE   CPUMATHMUL16BITTO32BIT_SIGNED4
    INCA
    BNE   CPUMATHMUL16BITTO32BIT_SIGNED4
    INC   1,S
    BNE   CPUMATHMUL16BITTO32BIT_SIGNED4
    INC   ,S
CPUMATHMUL16BITTO32BIT_SIGNED4
    PULS  X,PC

cpu_math_mul_16bit_to_32bit_after
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp23
	STD _Ttmp23+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp23+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xrnd
	STD _Ttmp26
	LDD _Ttmp20
	STD [_Ttmp26]
	LDX CURRENTHEIGHT
	STX _Ttmp9
; peephole: unsafe
;	LDD #$0000
	CLRA
; peephole: unsafe
;	STD _Ttmp14
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _Ttmp9
; peephole: rule #12 (LDD *->STD <tmp>->LDX *->CMPX <tmp>)
;	CMPX _Ttmp14
; peephole: rule #11 (LDr->CMPr #0)
;	CMPX #$0000
	BNE _label31
	DECA
_label31
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label32e0-(*+2))|(127-_label32e0+(*+2)))&0x8000)
	LBEQ _label32e0
	ELSE
	BEQ _label32e0
	ENDIF
_label32t
	IF (((128+_label29lr-(*+2))|(127-_label29lr+(*+2)))&0x8000)
	JMP _label29lr
	ELSE
	BRA _label29lr
	ENDIF
_label32f
_label32e0
	LDA (MO5TIMER+1)
	STA <PATTERN
	JSR CPURANDOM
	LDD CPURANDOM_SEED+2
	STD _Ttmp20
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp20
	LDX _Ttmp9
	JSR CPUMATHDIV16BITTO16BIT
	STX _Ttmp13
	STD _Ttmp12
	LDD _Ttmp13
	STD _Ttmp20
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD _Ttmp13
	STD _Ttmp23
	IF (((128+_label29end-(*+2))|(127-_label29end+(*+2)))&0x8000)
	JMP _label29end
	ELSE
	BRA _label29end
	ENDIF
_label29lr
	LDD _Ttmp23+2
	STD _Ttmp20
_label29end
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp34
	STD _Ttmp34+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp34+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_yrnd
	STD _Ttmp26
	LDD _Ttmp20
	STD [_Ttmp26]
	LDD _i
	ADDD _Ttmp3
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _i
	IF (((128+_label5bf-(*+2))|(127-_label5bf+(*+2)))&0x8000)
	JMP _label5bf
	ELSE
	BRA _label5bf
	ENDIF
_label5bis
	LDD #$0000
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp0
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _irnd
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _irnd
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
; peephole: rule #21 (B already 0)
;	CLRB
	STD _Ttmp0
; peephole: rule #20 (A already 0)
;	LDD #$0019
	LDB #$19
	STD _Ttmp2
	; _Ttmp36 <-> (step 1) (resident)
	; _Ttmp37 <-> (resident to) (resident)
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _Ttmp37
; peephole: rule #20 (A already 0)
;	LDD #$0001
	LDB #$01
	STD _Ttmp36
	LDD _Ttmp0
	STD _i
_label38bf
	CLRA
	LDX _i
	CMPX _Ttmp37
	BLS _label40
	DECA
_label40
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label38bis-(*+2))|(127-_label38bis+(*+2)))&0x8000)
	LBNE _label38bis
	ELSE
	BNE _label38bis
	ENDIF
_label41
	LDB #$10
	STB _Ttmp1
	CLRA
	STA _Ttmp44
; peephole: rule #17 (A already 0)
;	CLRA
	LDB _Ttmp1
	CMPB _Ttmp44
	BNE _label47
	DECA
_label47
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label48e0-(*+2))|(127-_label48e0+(*+2)))&0x8000)
	LBEQ _label48e0
	ELSE
	BEQ _label48e0
	ENDIF
_label48t
	IF (((128+_label45lr-(*+2))|(127-_label45lr+(*+2)))&0x8000)
	JMP _label45lr
	ELSE
	BRA _label45lr
	ENDIF
_label48f
_label48e0
	LDA (MO5TIMER+1)
	STA <PATTERN
	JSR CPURANDOM
	LDA CPURANDOM_SEED+3
	STA _Ttmp49
	IF (((128+cpu_math_div_8bit_to_8bit_after-(*+2))|(127-cpu_math_div_8bit_to_8bit_after+(*+2)))&0x8000)
	JMP cpu_math_div_8bit_to_8bit_after
	ELSE
	BRA cpu_math_div_8bit_to_8bit_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/

; unsigned 8 bit division A=A/B B=A.mod.A
; http://www.logicielsmoto.com/phpBB/viewtopic.php?p=1098#p1098


CPUMATHDIV8BITTO8BIT
    STB     CPUMATHDIV8BITTO8BIT1+3
    STB     CPUMATHDIV8BITTO8BIT2-1
    CLRB
    LDX     #8
CPUMATHDIV8BITTO8BIT1
    ROLA
    ROLB
    CMPB    #0
    BCS     CPUMATHDIV8BITTO8BIT2
    SUBB    #0
CPUMATHDIV8BITTO8BIT2
    LEAX    -1,X
    BNE     CPUMATHDIV8BITTO8BIT1
    ROLA
    COMA
    RTS

CPUMATHDIV8BITTO8BIT_SIGNED
    PSHS  D
    EORA  1,S
    STA   1,S    
    LDA   ,S+
    BPL   CPUMATHDIV8BITTO8BIT_SIGNED1
    NEGA
CPUMATHDIV8BITTO8BIT_SIGNED1
    TSTB
    BPL   CPUMATHDIV8BITTO8BIT_SIGNED2
    NEGB
CPUMATHDIV8BITTO8BIT_SIGNED2
    BSR   CPUMATHDIV8BITTO8BIT
    TST   ,S+
    BPL   CPUMATHDIV8BITTO8BIT_SIGNED3
    NEGA
CPUMATHDIV8BITTO8BIT_SIGNED3
    RTS

cpu_math_div_8bit_to_8bit_after
	LDA _Ttmp49
	LDB _Ttmp1
	JSR CPUMATHDIV8BITTO8BIT
	STB _Ttmp43
	STA _Ttmp42
	LDA _Ttmp43
	STA _Ttmp49
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDA _Ttmp43
	STA _Ttmp34
	IF (((128+_label45end-(*+2))|(127-_label45end+(*+2)))&0x8000)
	JMP _label45end
	ELSE
	BRA _label45end
	ENDIF
_label45lr
	LDA _Ttmp34+3
	STA _Ttmp49
_label45end
	CLRA
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STA _c
	LDA _Ttmp49
	STA _c
	LDD #$0000
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp1
	CLRA
	LDB _c
	CMPB _Ttmp1
	BNE _label51
	DECA
_label51
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	COMA
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label41-(*+2))|(127-_label41+(*+2)))&0x8000)
	LBEQ _label41
	ELSE
	BEQ _label41
	ENDIF
	LDX CURRENTWIDTH
	STX _Ttmp9
; peephole: unsafe
;	LDD #$0000
	CLRA
; peephole: unsafe
;	STD _Ttmp14
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _Ttmp9
; peephole: rule #12 (LDD *->STD <tmp>->LDX *->CMPX <tmp>)
;	CMPX _Ttmp14
; peephole: rule #11 (LDr->CMPr #0)
;	CMPX #$0000
	BNE _label56
	DECA
_label56
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label57e0-(*+2))|(127-_label57e0+(*+2)))&0x8000)
	LBEQ _label57e0
	ELSE
	BEQ _label57e0
	ENDIF
_label57t
	IF (((128+_label54lr-(*+2))|(127-_label54lr+(*+2)))&0x8000)
	JMP _label54lr
	ELSE
	BRA _label54lr
	ENDIF
_label57f
_label57e0
	LDA (MO5TIMER+1)
	STA <PATTERN
	JSR CPURANDOM
	LDD CPURANDOM_SEED+2
	STD _Ttmp20
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp20
	LDX _Ttmp9
	JSR CPUMATHDIV16BITTO16BIT
	STX _Ttmp13
	STD _Ttmp12
	LDD _Ttmp13
	STD _Ttmp20
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD _Ttmp13
	STD _Ttmp53
	IF (((128+_label54end-(*+2))|(127-_label54end+(*+2)))&0x8000)
	JMP _label54end
	ELSE
	BRA _label54end
	ENDIF
_label54lr
	LDD _Ttmp53+2
	STD _Ttmp20
_label54end
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp59
	STD _Ttmp59+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp59+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xtab
	STD _Ttmp26
	LDD _Ttmp20
	STD [_Ttmp26]
	LDX CURRENTHEIGHT
	STX _Ttmp9
; peephole: unsafe
;	LDD #$0000
	CLRA
; peephole: unsafe
;	STD _Ttmp14
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _Ttmp9
; peephole: rule #12 (LDD *->STD <tmp>->LDX *->CMPX <tmp>)
;	CMPX _Ttmp14
; peephole: rule #11 (LDr->CMPr #0)
;	CMPX #$0000
	BNE _label64
	DECA
_label64
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label65e0-(*+2))|(127-_label65e0+(*+2)))&0x8000)
	LBEQ _label65e0
	ELSE
	BEQ _label65e0
	ENDIF
_label65t
	IF (((128+_label62lr-(*+2))|(127-_label62lr+(*+2)))&0x8000)
	JMP _label62lr
	ELSE
	BRA _label62lr
	ENDIF
_label65f
_label65e0
	LDA (MO5TIMER+1)
	STA <PATTERN
	JSR CPURANDOM
	LDD CPURANDOM_SEED+2
	STD _Ttmp20
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp20
	LDX _Ttmp9
	JSR CPUMATHDIV16BITTO16BIT
	STX _Ttmp13
	STD _Ttmp12
	LDD _Ttmp13
	STD _Ttmp20
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD _Ttmp13
	STD _Ttmp59
	IF (((128+_label62end-(*+2))|(127-_label62end+(*+2)))&0x8000)
	JMP _label62end
	ELSE
	BRA _label62end
	ENDIF
_label62lr
	LDD _Ttmp59+2
	STD _Ttmp20
_label62end
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_ytab
	STD _Ttmp26
	LDD _Ttmp20
	STD [_Ttmp26]
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	ADDD #_ctab
	STD _Ttmp25
	LDA _c
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	STA [_Ttmp25]
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xtab
	STD _Ttmp26
	LDD [_Ttmp26]
	STD _Ttmp9
	LDD #$0000
	STD _Ttmp75
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp73
	LDD _i
	LDX _Ttmp73
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp76
	STD _Ttmp76+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp76+2
	STD _Ttmp77
	LDD _Ttmp75
	ADDD _Ttmp77
	STD _Ttmp78
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp78
	STD _Ttmp79
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp79
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp79
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp79
	ADDD #_ytab
	STD _Ttmp79
	LDD [_Ttmp79]
	STD _Ttmp12
	LDD #$0000
	STD _Ttmp84
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp82
	LDD _i
	LDX _Ttmp82
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp85
	STD _Ttmp85+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp85+2
	STD _Ttmp86
	LDD _Ttmp84
	ADDD _Ttmp86
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp87
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp87
	ADDD #_ctab
	STD _Ttmp87
	LDA [_Ttmp87]
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	STA _PEN
	IF (((128+plot_after-(*+2))|(127-plot_after+(*+2)))&0x8000)
	JMP plot_after
	ELSE
	BRA plot_after
	ENDIF
; /*****************************************************************************
;  * ugBASIC - an isomorphic BASIC language compiler for retrocomputers        *
;  *****************************************************************************
;  * Copyright 2021 Marco Spedaletti (asimov@mclink.it)
;  *
;  * Licensed under the Apache License, Version 2.0 (the "License");
;  * you may not use this file except in compliance with the License.
;  * You may obtain a copy of the License at
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Unless required by applicable law or agreed to in writing, software
;  * distributed under the License is distributed on an "AS IS" BASIS,
;  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;  * See the License for the specific language governing permissions and
;  * limitations under the License.
;  *----------------------------------------------------------------------------
;  * Concesso in licenza secondo i termini della Licenza Apache, versione 2.0
;  * (la "Licenza"); è proibito usare questo file se non in conformità alla
;  * Licenza. Una copia della Licenza è disponibile all'indirizzo:
;  *
;  * http://www.apache.org/licenses/LICENSE-2.0
;  *
;  * Se non richiesto dalla legislazione vigente o concordato per iscritto,
;  * il software distribuito nei termini della Licenza è distribuito
;  * "COSì COM'è", SENZA GARANZIE O CONDIZIONI DI ALCUN TIPO, esplicite o
;  * implicite. Consultare la Licenza per il testo specifico che regola le
;  * autorizzazioni e le limitazioni previste dalla medesima.
;  ****************************************************************************/
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;*                           PLOT ROUTINE FOR EF936X                           *
;*                                                                             *
;*                             by Marco Spedaletti                             *
;*                     mc6809 optimization by Samuel Devulder                  *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

PLOTX   EQU $41 ; $42
PLOTY   EQU $43
PLOTM   EQU $45
PLOTOMA EQU $46
PLOTAMA EQU $47

;--------------

PLOTP
    RTS

PLOT
    LDX <PLOTY
    CMPX CLIPY2   ; CMPX is faster than CMPD
    BGT PLOTP
    CMPX CLIPY1
    BLT PLOTP
    LDX <PLOTX
    CMPX CLIPX2
    BGT PLOTP
    CMPX CLIPX1   ; check if plotting out of clipped area
    BLT PLOTP     ; yes => return

    LDB <PLOTY+1  ; no => compute video adress
    LDA #40
    MUL
    ADDD BITMAPADDRESS ; 7
    TFR D,X ; 6
    
    LDU #$A7C0    ; that adress is handy
    
PLOTMODE
    LDA CURRENTMODE
    CMPA #3       ; mode 3 ?
    BNE PLOT0     ; no => goto common adress decoding

PLOT3             ; yes
    LDA ,U
    ORA #1        ; prepare A for plane 1
    
    LDB <PLOTX+1
    LSRB
    LSRB          ; carry = bit2
    ABX           ; adjust for X position

    SBCA #0       ; chose plane 0/1 according bit 2 of X coordinate
    STA ,U        ; select proper plane
    
    BRA PLOTCOMMON
    
PLOTD             ; plot draw (placed here to keep the jump small)
    LDA CURRENTMODE
    CMPA #2
    BEQ PLOTD2    ; plot in mode 2
    CMPA #3
    BEQ PLOTD3    ; plot in mode 3

PLOTD0
PLOTD1
PLOTD4     
    LDA _PEN      ; other modes - asked color
    EORA ,X       ; compare with bg colo
    ANDA #$0F
    BEQ PLOTE     ; equal ? yes ==> erase pixel
    
    LDA _PEN      ; no ==> regular plot
    LSLA          
    LSLA
    LSLA
    LSLA
    STA PLOTD4x+1 ; prepare paper colo
    
    LDA ,X        ; get color pair
    ANDA #$0F     ; clear paper color
PLOTD4x
    ORA #0        ; add current paper color
    STA ,X        ; set color
    
    ;---------
    ;set point
    ;---------
    INC ,U        ; form plane
    LDA ,X        ; get byte
    ORA ,Y        ; set bit
    STA ,X        ; write back to video memory
    RTS           ; done

    ;-----------
    ;erase point
    ;-----------
PLOTE
    INC ,U        ; form plane
    LDA ,X        ; get bit mask
    ANDA 8,Y      ; clear bit
    STA ,X        ; write back to video memory
    RTS           ; done
   
PLOT0
PLOT1
PLOT2
PLOT4
    LDD <PLOTX    ; common adress calculation for modes
    LSRA          ; 0/1/2/4
    RORB
    LSRB
    LSRB          ; B = PLOTX/8
    ABX           ; adjust for X position
    
    LDY #PLOTORBIT
    LDB <(PLOTX+1)
    ANDB #$07
    LEAY B,Y      ; Y point to "OR" bitmask, Y+8 to "AND" bitmask

    LDB ,U        ; select color plane
    ANDB #254
    STB ,U

PLOTCOMMON
    ;----------------------------------------------
    ;depending on PLOTM, routine draws or erases
    ;----------------------------------------------
    LDA <PLOTM    ; (0 = erase, 1 = set, 2 = get pixel, 3 = get color)
    BEQ PLOTE       
    DECA            
    BEQ PLOTD     ; if = 1 then branch to draw the point
    DECA            
    BEQ PLOTG     ; if = 2 then branch to get the point (0/1)
    DECA            
    BEQ PLOTC     ; if = 3 then branch to get the color index (0...15)
    RTS

PLOTD2            ; Draw point with mode 2 (we are in plane0)
    LDA ,X        ; get row with point in it
    LDB _PEN      
    LSRB          ; b0 of PEN set ?
    BCC PLOTD21   ; no => clear bit
    ORA ,Y        ; yes => set bit
    BRA PLOTD22
PLOTD21
    ANDA 8,Y
PLOTD22
    STA ,X        ; write back to video memory

    INC ,U        ; plane 1
    LDA ,X        ; get mask with point in it
    LSRB          ; b1 of PEN set ?
    BCC PLOTD24   ; no => clear BIT
    ORA ,Y        ; yes => set BIT
    BRA PLOTD25
PLOTD24
    ANDA 8,Y
PLOTD25
    STA ,X        ; write back to video memory
    RTS           ; done

PLOTD3
    LDA _PEN      ; Draw point in mode 3
    ANDA #$0F     ; isolate color
    LDB <(PLOTX+1)
    LSRB          ; odd column ?
    BCS PLOTD3LO  ; yes => set low nibble

PLOTD3HI
    ASLA          ; no => set high nibble
    ASLA
    ASLA
    ASLA
    STA PLOTD3nibble+1
    LDA ,X
    ANDA #$0F
PLOTD3nibble
    ORA #$55
    STA ,X
    RTS           ; done

PLOTD3LO
    STA PLOTD3nibble+1
    LDA ,X
    ANDA #$F0
    BRA PLOTD3nibble

PLOTG             ; get point $00=unset $ff=set
    LDA CURRENTMODE
    CMPA #2
    BEQ PLOTG2
    CMPA #3
    BEQ PLOTG3
    INC ,U        ; plane 1
    LDA ,X        ; get row with point in it
    ANDA ,Y       ; bit set ?
PLOTG0
    BEQ PLOTG1    ; no => return 0
    LDA #$FF      ; yes => return true
PLOTG1
    STA <PLOTM
    RTS
PLOTG2
PLOTG3
    BSR PLOTC     ; get current color
    EORA _PAPER   ; same as paper ?
    ANDA #$0F     ; yes => return 0
    BRA PLOTG0    ; no => return true

; Get pixel color according to video mode
PLOTC
    LDA CURRENTMODE
    CMPA #2
    BEQ PLOT2C    ; mode 2 specific
    CMPA #3
    BEQ PLOT3C    ; mode 3 specific
PLOT0C
PLOT1C
PLOT4C            ; modes 0/1/4
    LDA ,X        ; get color byte
    INC ,U        ; bitmask plane
    LDB ,X        ; get pixels byte
    ANDB ,Y       ; bit set ?
    BEQ PLOTC01   ; no => get lowwer nibble
PLOTC00    
    LSRA          ; yes => get upper nibble
    LSRA
    LSRA
    LSRA
PLOTC01
    ANDA #15
    STA <PLOTM    ; store result (in A also)
    RTS

PLOT2C
    CLRA          ; mode 2 - clear all bits
    LDB ,X        ; get bitmask at plane0
    ANDB ,Y       ; point set ?   
    BEQ PLOT2C0   ; no => skip
    INCA          ; yes => set b0
PLOT2C0
    INC ,U        ; bit plane 1
    LDB ,X        ; get bitmask
    ANDB ,Y       ; point set ?
    BEQ PLOT2C1   ; no => skip
    ORA #2        ; yes => set b1
PLOT2C1    
    STA <PLOTM    ; store result (in A also)
    RTS

PLOT3C
    LDA ,X        ; mode 3 - get color pair
    LDB <PLOTX+1
    LSRB
    BCS PLOTC01   ; odd column => lower nibble
    BRA PLOTC00   ; even column => upper nibble

;----------------------------------------------------------------

PLOTORBIT
    fcb %10000000
    fcb %01000000
    fcb %00100000
    fcb %00010000
    fcb %00001000
    fcb %00000100
    fcb %00000010
    fcb %00000001

PLOTANDBIT
    fcb %01111111
    fcb %10111111
    fcb %11011111
    fcb %11101111
    fcb %11110111
    fcb %11111011
    fcb %11111101
    fcb %11111110


plot_after
	LDX _Ttmp9
	STX <PLOTX
	LDD _Ttmp12
	STD <PLOTY
	LDA #1
	STA <PLOTM
	JSR PLOT
	LDD _i
	ADDD _Ttmp36
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _i
	IF (((128+_label38bf-(*+2))|(127-_label38bf+(*+2)))&0x8000)
	JMP _label38bf
	ELSE
	BRA _label38bf
	ENDIF
_label38bis
	LDX CURRENTWIDTH
	STX _Ttmp9
	LDD #$0002
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _Ttmp12
	LDD _Ttmp9
	LDX _Ttmp12
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp22
	STD _Ttmp2
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _x0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _x0
	LDX CURRENTHEIGHT
	STX _Ttmp9
	LDD #$0002
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _Ttmp12
	LDD _Ttmp9
	LDX _Ttmp12
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp22
	STD _Ttmp2
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _y0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _y0
_label91
	LDB #$07
	STB _Ttmp1
	LDA _Ttmp1
	STA _PEN
	LDX _x0
	STX <PLOTX
	LDD _y0
	STD <PLOTY
	LDA #1
	STA <PLOTM
	JSR PLOT
	LDD #$0000
	STD _Ttmp0
; peephole: rule #20 (A already 0)
;	LDD #$0019
	LDB #$19
	STD _Ttmp2
	; _Ttmp92 <-> (step 1) (resident)
	; _Ttmp93 <-> (resident to) (resident)
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _Ttmp93
; peephole: rule #20 (A already 0)
;	LDD #$0001
	LDB #$01
	STD _Ttmp92
	LDD _Ttmp0
	STD _i
_label94bf
	CLRA
	LDX _i
	CMPX _Ttmp93
	BLS _label96
	DECA
_label96
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label94bis-(*+2))|(127-_label94bis+(*+2)))&0x8000)
	LBNE _label94bis
	ELSE
	BNE _label94bis
	ENDIF
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xtab
	STD _Ttmp26
	LDD [_Ttmp26]
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp9
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _z
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp9
	STD _z
	LDD _x0
	STD _Ttmp9
	LDD _z
	SUBD _Ttmp9
	STD _Ttmp12
	LDD #$0008
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _Ttmp13
	LDD _Ttmp12
	LDX _Ttmp13
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp22
	STD _Ttmp2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _Ttmp14
	LDD _z
	ADDD _Ttmp14
	STD _Ttmp20
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _x
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp20
	STD _x
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_ytab
	STD _Ttmp26
	LDD [_Ttmp26]
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp9
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _t
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp9
	STD _t
	LDD _y0
	STD _Ttmp9
	LDD _t
	SUBD _Ttmp9
	STD _Ttmp12
	LDD #$0008
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _Ttmp13
	LDD _Ttmp12
	LDX _Ttmp13
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp22
	STD _Ttmp2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _Ttmp14
	LDD _t
	ADDD _Ttmp14
	STD _Ttmp20
; peephole: rule #8 (LDr->LDr)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _y
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp20
	STD _y
	LDD _x
	ORA _y
	ORB _y+1
	STD _Ttmp9
	LDD #$0000
	STD _Ttmp0
	LDX CURRENTHEIGHT
	STX _Ttmp12
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _y
	CMPX _Ttmp12
	BLE _label104
	DECA
_label104
	STA _Ttmp7
	LDX CURRENTWIDTH
	STX _Ttmp13
	CLRA
	LDX _x
	CMPX _Ttmp13
	BLE _label107
	DECA
_label107
	STA _Ttmp17
	LDA _Ttmp7
	ORA _Ttmp17
	STA _Ttmp108
	LDD #$0000
	STD _Ttmp2
	LDA _Ttmp108
	STA _Ttmp2+1
	LDD _Ttmp0
	ORA _Ttmp2
	ORB _Ttmp2+1
	STD _Ttmp22
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp22
	STD _Ttmp14
	CLRA
	LDX _Ttmp9
	CMPX _Ttmp14
	BGE _label113
	DECA
_label113
	STA _Ttmp112
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp112
	IF (((128+_label114e0-(*+2))|(127-_label114e0+(*+2)))&0x8000)
	LBEQ _label114e0
	ELSE
	BEQ _label114e0
	ENDIF
_label114t
_label115
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _irnd
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xrnd
	STD _Ttmp26
	LDD [_Ttmp26]
	STD _Ttmp9
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp9
	STD _x
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _irnd
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_yrnd
	STD _Ttmp26
	LDD [_Ttmp26]
	STD _Ttmp9
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp9
	STD _y
	LDD #$0001
	STD _Ttmp0
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
	CLRB
	STD _Ttmp2
	LDD #$03e8
	STD _Ttmp22
	LDD _irnd
	ADDD _Ttmp0
	STD _Ttmp24
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp24
	STD _irnd
	CLRA
	LDX _irnd
	CMPX _Ttmp2
	BHS _label122
	DECA
_label122
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label120g-(*+2))|(127-_label120g+(*+2)))&0x8000)
	LBEQ _label120g
	ELSE
	BEQ _label120g
	ENDIF
	LDD _Ttmp22
	STD _irnd
	IF (((128+_label120e-(*+2))|(127-_label120e+(*+2)))&0x8000)
	JMP _label120e
	ELSE
	BRA _label120e
	ENDIF
_label120g
	CLRA
	LDX _irnd
	CMPX _Ttmp22
	BLS _label124
	DECA
_label124
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label120e-(*+2))|(127-_label120e+(*+2)))&0x8000)
	LBEQ _label120e
	ELSE
	BEQ _label120e
	ENDIF
	LDD _Ttmp2
	STD _irnd
_label120e
	LDD _x0
	STD _Ttmp9
	LDD _x
	SUBD _Ttmp9
	STD _Ttmp12
	LDD #$0008
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _Ttmp13
	LDD _Ttmp12
	LDX _Ttmp13
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp22
	STD _Ttmp2
	LDD _y0
	STD _Ttmp14
	LDD _y
	SUBD _Ttmp14
	STD _Ttmp20
	LDD #$0008
	STD _Ttmp24
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp24
	STD _Ttmp125
	LDD _Ttmp20
	LDX _Ttmp125
	JSR CPUMATHDIV16BITTO16BIT_SIGNED
	STX _Ttmp26
	STD _Ttmp25
	LDD _Ttmp2
	ANDA _Ttmp25
	ANDB _Ttmp25+1
	STD _Ttmp73
	LDA _Ttmp73+1
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label115-(*+2))|(127-_label115+(*+2)))&0x8000)
	LBEQ _label115
	ELSE
	BEQ _label115
	ENDIF
_label114f
_label114e0
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_xtab
	STD _Ttmp26
	LDD _x
	STD [_Ttmp26]
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	LSLB
	ROLA
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp26
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp26
	ADDD #_ytab
	STD _Ttmp26
	LDD _y
	STD [_Ttmp26]
	LDD #$0000
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp1
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp1
	STA _PEN
	LDX _z
	STX <PLOTX
	LDD _t
	STD <PLOTY
	LDA #1
	STA <PLOTM
	JSR PLOT
	LDD #$0000
	STD _Ttmp22
; peephole: rule #20 (A already 0)
;	LDD #$0001
; peephole: rule #23 (B was 0)
;	LDB #$01
	INCB
	STD _Ttmp0
	LDD _i
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _Ttmp24
	LDD _Ttmp22
	ADDD _Ttmp24
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp25
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp25
	ADDD #_ctab
	STD _Ttmp25
	LDA [_Ttmp25]
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	STA _PEN
	LDX _x
	STX <PLOTX
	LDD _y
	STD <PLOTY
	LDA #1
	STA <PLOTM
	JSR PLOT
	LDD _i
	ADDD _Ttmp92
	STD _Ttmp0
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _i
	IF (((128+_label94bf-(*+2))|(127-_label94bf+(*+2)))&0x8000)
	JMP _label94bf
	ELSE
	BRA _label94bf
	ENDIF
_label94bis
	LDD #$0000
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp7
	LDA $A7CC
	LDB _Ttmp7
	BEQ _label133joy0
	LDB #$40
	LSRA
	LSRA
	LSRA
	LSRA
_label133joy0
	ANDA #$0F
	ADDB #$40
	ANDB $A7CD
	BEQ _label133act0
	ADDA #$10
_label133act0
	EORA #$1F
	STA _Ttmp17
	CLRA
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STA _joy
	LDA _Ttmp17
	STA _joy
	LDD #$0000
; peephole: rule #15 (STr->...->STr)
;	STD _Ttmp0
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _dx
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _dx
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
; peephole: rule #21 (B already 0)
;	CLRB
	STD _Ttmp0
; peephole: rule #6 (LD* Z->ST*->LD* Z)
;	LDD #$0000
; peephole: rule #7 (STr Z->LD*->STr Z)
;	STD _dy
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp0
	STD _dy
	LDB #$02
	STB _Ttmp7
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
	CLRB
	STD _Ttmp67
	STD _Ttmp67+2
	LDA _joy
	STA _Ttmp67+3
	LDA #1
	LDB _Ttmp7
	ANDB #$07
_label135
	CMPB #0
	BEQ _label135done
	LSLA
	DECB
	JMP _label135
_label135done
	STA <MATHPTR0
	LDB _Ttmp7
	CMPB #24
	BLO _label135_24
	LDA _Ttmp67
	JMP _label135eval
_label135_24
	CMPB #16
	BLO _label135_16
	LDA _Ttmp67+1
	JMP _label135eval
_label135_16
	CMPB #8
	BLO _label135_8
	LDA _Ttmp67+2
	JMP _label135eval
_label135_8
	LDA _Ttmp67+3
	JMP _label135eval
_label135eval
	ANDA <MATHPTR0
	CMPA #0
	BEQ _label135zero
_label135one
	LDA #$ff
	JMP _label135end
_label135zero
	LDA #$0
_label135end
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label134unset-(*+2))|(127-_label134unset+(*+2)))&0x8000)
	LBEQ _label134unset
	ELSE
	BEQ _label134unset
	ENDIF
_label134set
	LDB #$ff
	STB _Ttmp17
	IF (((128+_label134end-(*+2))|(127-_label134end+(*+2)))&0x8000)
	JMP _label134end
	ELSE
	BRA _label134end
	ENDIF
_label134unset
	CLRA
	STA _Ttmp17
_label134end
	LDA _Ttmp17
	IF (((128+_label136e0-(*+2))|(127-_label136e0+(*+2)))&0x8000)
	LBEQ _label136e0
	ELSE
	BEQ _label136e0
	ENDIF
_label136t
	LDD _dx
	SUBD #1
	STD _dx
_label136f
_label136e0
	LDB #$03
	STB _Ttmp7
	LDD #$0000
	STD _Ttmp67
	STD _Ttmp67+2
	LDA _joy
	STA _Ttmp67+3
	LDA #1
	LDB _Ttmp7
	ANDB #$07
_label138
	CMPB #0
	BEQ _label138done
	LSLA
	DECB
	JMP _label138
_label138done
	STA <MATHPTR0
	LDB _Ttmp7
	CMPB #24
	BLO _label138_24
	LDA _Ttmp67
	JMP _label138eval
_label138_24
	CMPB #16
	BLO _label138_16
	LDA _Ttmp67+1
	JMP _label138eval
_label138_16
	CMPB #8
	BLO _label138_8
	LDA _Ttmp67+2
	JMP _label138eval
_label138_8
	LDA _Ttmp67+3
	JMP _label138eval
_label138eval
	ANDA <MATHPTR0
	CMPA #0
	BEQ _label138zero
_label138one
	LDA #$ff
	JMP _label138end
_label138zero
	LDA #$0
_label138end
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label137unset-(*+2))|(127-_label137unset+(*+2)))&0x8000)
	LBEQ _label137unset
	ELSE
	BEQ _label137unset
	ENDIF
_label137set
	LDB #$ff
	STB _Ttmp17
	IF (((128+_label137end-(*+2))|(127-_label137end+(*+2)))&0x8000)
	JMP _label137end
	ELSE
	BRA _label137end
	ENDIF
_label137unset
	CLRA
	STA _Ttmp17
_label137end
	LDA _Ttmp17
	IF (((128+_label139e0-(*+2))|(127-_label139e0+(*+2)))&0x8000)
	LBEQ _label139e0
	ELSE
	BEQ _label139e0
	ENDIF
_label139t
	INC _dx+1
	BNE _label140
	INC _dx
_label140
_label139f
_label139e0
	CLRA
	STA _Ttmp7
; peephole: rule #20 (A already 0)
;	LDD #$0000
; peephole: rule #5 (LDr #0->CLRr)
;	LDB #$00
	CLRB
	STD _Ttmp67
	STD _Ttmp67+2
	LDA _joy
	STA _Ttmp67+3
	LDA #1
	LDB _Ttmp7
	ANDB #$07
_label142
	CMPB #0
	BEQ _label142done
	LSLA
	DECB
	JMP _label142
_label142done
	STA <MATHPTR0
	LDB _Ttmp7
	CMPB #24
	BLO _label142_24
	LDA _Ttmp67
	JMP _label142eval
_label142_24
	CMPB #16
	BLO _label142_16
	LDA _Ttmp67+1
	JMP _label142eval
_label142_16
	CMPB #8
	BLO _label142_8
	LDA _Ttmp67+2
	JMP _label142eval
_label142_8
	LDA _Ttmp67+3
	JMP _label142eval
_label142eval
	ANDA <MATHPTR0
	CMPA #0
	BEQ _label142zero
_label142one
	LDA #$ff
	JMP _label142end
_label142zero
	LDA #$0
_label142end
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label141unset-(*+2))|(127-_label141unset+(*+2)))&0x8000)
	LBEQ _label141unset
	ELSE
	BEQ _label141unset
	ENDIF
_label141set
	LDB #$ff
	STB _Ttmp17
	IF (((128+_label141end-(*+2))|(127-_label141end+(*+2)))&0x8000)
	JMP _label141end
	ELSE
	BRA _label141end
	ENDIF
_label141unset
	CLRA
	STA _Ttmp17
_label141end
	LDA _Ttmp17
	IF (((128+_label143e0-(*+2))|(127-_label143e0+(*+2)))&0x8000)
	LBEQ _label143e0
	ELSE
	BEQ _label143e0
	ENDIF
_label143t
	LDD _dy
	SUBD #1
	STD _dy
_label143f
_label143e0
	LDB #$01
	STB _Ttmp7
	LDD #$0000
	STD _Ttmp67
	STD _Ttmp67+2
	LDA _joy
	STA _Ttmp67+3
	LDA #1
	LDB _Ttmp7
	ANDB #$07
_label145
	CMPB #0
	BEQ _label145done
	LSLA
	DECB
	JMP _label145
_label145done
	STA <MATHPTR0
	LDB _Ttmp7
	CMPB #24
	BLO _label145_24
	LDA _Ttmp67
	JMP _label145eval
_label145_24
	CMPB #16
	BLO _label145_16
	LDA _Ttmp67+1
	JMP _label145eval
_label145_16
	CMPB #8
	BLO _label145_8
	LDA _Ttmp67+2
	JMP _label145eval
_label145_8
	LDA _Ttmp67+3
	JMP _label145eval
_label145eval
	ANDA <MATHPTR0
	CMPA #0
	BEQ _label145zero
_label145one
	LDA #$ff
	JMP _label145end
_label145zero
	LDA #$0
_label145end
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label144unset-(*+2))|(127-_label144unset+(*+2)))&0x8000)
	LBEQ _label144unset
	ELSE
	BEQ _label144unset
	ENDIF
_label144set
	LDB #$ff
	STB _Ttmp17
	IF (((128+_label144end-(*+2))|(127-_label144end+(*+2)))&0x8000)
	JMP _label144end
	ELSE
	BRA _label144end
	ENDIF
_label144unset
	CLRA
	STA _Ttmp17
_label144end
	LDA _Ttmp17
	IF (((128+_label146e0-(*+2))|(127-_label146e0+(*+2)))&0x8000)
	LBEQ _label146e0
	ELSE
	BEQ _label146e0
	ENDIF
_label146t
	INC _dy+1
	BNE _label147
	INC _dy
_label147
_label146f
_label146e0
	LDD _dx
	ORA _dy
	ORB _dy+1
	STD _Ttmp0
; peephole: unsafe
;	LDD #$0000
	CLRA
; peephole: unsafe
;	STD _Ttmp2
; peephole: rule #17 (A already 0)
;	CLRA
	LDX _Ttmp0
; peephole: rule #12 (LDD *->STD <tmp>->LDX *->CMPX <tmp>)
;	CMPX _Ttmp2
; peephole: rule #11 (LDr->CMPr #0)
;	CMPX #$0000
	BNE _label150
	DECA
_label150
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	COMA
	STA _Ttmp17
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp17
	IF (((128+_label151e0-(*+2))|(127-_label151e0+(*+2)))&0x8000)
	LBEQ _label151e0
	ELSE
	BEQ _label151e0
	ENDIF
_label151t
	LDB #$04
	STB _Ttmp7
	LDD #$0000
	STD _Ttmp67
	STD _Ttmp67+2
	LDA _joy
	STA _Ttmp67+3
	LDA #1
	LDB _Ttmp7
	ANDB #$07
_label153
	CMPB #0
	BEQ _label153done
	LSLA
	DECB
	JMP _label153
_label153done
	STA <MATHPTR0
	LDB _Ttmp7
	CMPB #24
	BLO _label153_24
	LDA _Ttmp67
	JMP _label153eval
_label153_24
	CMPB #16
	BLO _label153_16
	LDA _Ttmp67+1
	JMP _label153eval
_label153_16
	CMPB #8
	BLO _label153_8
	LDA _Ttmp67+2
	JMP _label153eval
_label153_8
	LDA _Ttmp67+3
	JMP _label153eval
_label153eval
	ANDA <MATHPTR0
	CMPA #0
	BEQ _label153zero
_label153one
	LDA #$ff
	JMP _label153end
_label153zero
	LDA #$0
_label153end
	STA _Ttmp108
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp108
	IF (((128+_label152unset-(*+2))|(127-_label152unset+(*+2)))&0x8000)
	LBEQ _label152unset
	ELSE
	BEQ _label152unset
	ENDIF
_label152set
	LDB #$ff
	STB _Ttmp108
	IF (((128+_label152end-(*+2))|(127-_label152end+(*+2)))&0x8000)
	JMP _label152end
	ELSE
	BRA _label152end
	ENDIF
_label152unset
	CLRA
	STA _Ttmp108
_label152end
	LDA _Ttmp108
	IF (((128+_label154e0-(*+2))|(127-_label154e0+(*+2)))&0x8000)
	LBEQ _label154e0
	ELSE
	BEQ _label154e0
	ENDIF
_label154t
	LDD #$0004
	STD _Ttmp0
	LDD _dx
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _dx
	LDD #$0004
	STD _Ttmp0
	LDD _dy
	LDX _Ttmp0
	JSR CPUMATHMUL16BITTO32BIT
	STX _Ttmp67
	STD _Ttmp67+2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp67+2
	STD _dy
_label154f
_label154e0
	LDD #$0000
	STD _Ttmp0
	LDA _Ttmp0+1
	STA _Ttmp1
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp1
	STA _PEN
	LDX _x0
	STX <PLOTX
	LDD _y0
	STD <PLOTY
	LDA #1
	STA <PLOTM
	JSR PLOT
	LDD #$0000
	STD _Ttmp0
	LDX CURRENTWIDTH
	STX _Ttmp9
	LDD _x0
	ADDD _dx
	STD _Ttmp2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _x0
	CLRA
	LDX _x0
	CMPX _Ttmp0
	BHS _label158
	DECA
_label158
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label156g-(*+2))|(127-_label156g+(*+2)))&0x8000)
	LBEQ _label156g
	ELSE
	BEQ _label156g
	ENDIF
	LDD _Ttmp9
	STD _x0
	IF (((128+_label156e-(*+2))|(127-_label156e+(*+2)))&0x8000)
	JMP _label156e
	ELSE
	BRA _label156e
	ENDIF
_label156g
	LDD _x0
	STD _Ttmp160
	LDD _Ttmp9
	STD _Ttmp161
	CLRA
	LDX _Ttmp160
	CMPX _Ttmp161
	BLE _label162
	DECA
_label162
	STA _Ttmp108
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp108
	IF (((128+_label156e-(*+2))|(127-_label156e+(*+2)))&0x8000)
	LBEQ _label156e
	ELSE
	BEQ _label156e
	ENDIF
	LDD _Ttmp0
	STD _x0
_label156e
	LDD #$0000
	STD _Ttmp0
	LDX CURRENTHEIGHT
	STX _Ttmp9
	LDD _y0
	ADDD _dy
	STD _Ttmp2
; peephole: rule #2 (STD->LDD)
;	LDD _Ttmp2
	STD _y0
	CLRA
	LDX _y0
	CMPX _Ttmp0
	BHS _label166
	DECA
_label166
	STA _Ttmp7
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp7
	IF (((128+_label164g-(*+2))|(127-_label164g+(*+2)))&0x8000)
	LBEQ _label164g
	ELSE
	BEQ _label164g
	ENDIF
	LDD _Ttmp9
	STD _y0
	IF (((128+_label164e-(*+2))|(127-_label164e+(*+2)))&0x8000)
	JMP _label164e
	ELSE
	BRA _label164e
	ENDIF
_label164g
	LDD _y0
	STD _Ttmp160
	LDD _Ttmp9
	STD _Ttmp161
	CLRA
	LDX _Ttmp160
	CMPX _Ttmp161
	BLE _label168
	DECA
_label168
	STA _Ttmp108
; peephole: rule #1 (STr->LDr)
;	LDA _Ttmp108
	IF (((128+_label164e-(*+2))|(127-_label164e+(*+2)))&0x8000)
	LBEQ _label164e
	ELSE
	BEQ _label164e
	ENDIF
	LDD _Ttmp0
	STD _y0
_label164e
_label151f
_label151e0
	IF (((128+_label91-(*+2))|(127-_label91+(*+2)))&0x8000)
	JMP _label91
	ELSE
	BRA _label91
	ENDIF
_label91bis
	; HALT
_label169
	IF (((128+_label169-(*+2))|(127-_label169+(*+2)))&0x8000)
	JMP _label169
	ELSE
	BRA _label169
	ENDIF
_PEN rzb 1
_PAPER rzb 1
_windowE rzb 1
_windowS rzb 1
_windowW rzb 1
_windowT rzb 1
_TAB fcb 1
   fcc "	"
_windowMX rzb 1
_windowMY rzb 1
_xrnd rzb 2002
_yrnd rzb 2002
_xtab rzb 52
_ytab rzb 52
_ctab rzb 26
_i rzb 2
_irnd rzb 2
_c rzb 1
_x0 rzb 2
_y0 rzb 2
_z rzb 2
_x rzb 2
_t rzb 2
_y rzb 2
_joy rzb 1
_dx rzb 2
_dy rzb 2
_Ttmp0 rzb 2
_Ttmp1 rzb 1
_Ttmp2 rzb 2
_Ttmp7 rzb 1
_Ttmp9 rzb 2
_Ttmp11 rzb 4
_Ttmp12 rzb 2
_Ttmp13 rzb 2
_Ttmp14 rzb 2
_Ttmp17 rzb 1
_Ttmp20 rzb 2
_Ttmp22 rzb 2
_Ttmp23 rzb 4
_Ttmp24 rzb 2
_Ttmp25 rzb 2
_Ttmp26 rzb 2
_Ttmp34 rzb 4
_Ttmp42 rzb 1
_Ttmp43 rzb 1
_Ttmp44 rzb 1
_Ttmp49 rzb 1
_Ttmp53 rzb 4
_Ttmp59 rzb 4
_Ttmp67 rzb 4
_Ttmp73 rzb 2
_Ttmp74 rzb 2
_Ttmp75 rzb 2
_Ttmp76 rzb 4
_Ttmp77 rzb 2
_Ttmp78 rzb 2
_Ttmp79 rzb 2
_Ttmp82 rzb 2
_Ttmp83 rzb 2
_Ttmp84 rzb 2
_Ttmp85 rzb 4
_Ttmp86 rzb 2
_Ttmp87 rzb 2
_Ttmp108 rzb 1
_Ttmp112 rzb 1
_Ttmp125 rzb 2
_Ttmp160 rzb 2
_Ttmp161 rzb 2
_Ttmp3 rzb 2
_Ttmp4 rzb 2
_Ttmp36 rzb 2
_Ttmp37 rzb 2
_Ttmp92 rzb 2
_Ttmp93 rzb 2
COMMONPALETTE
      fdb $0000, $0008, $05c0, $07ee, $0a00, $0c4c, $0efa, $0fff, $0777, $077f, $06fa, $068d, $0f80, $0e5e, $0ffe, 	$036a
; peephole: pass 1, 189 changes.
; peephole: pass 2, 45 changes.
; peephole: pass 3, 17 changes.
; peephole: pass 4, 5 changes.
; peephole: pass 5, 0 change.
